#pragma rtGlobals=1		// Use modern global access method.
#include <WaveSelectorWidget>

constant Kbit_ListboxSelected=0x01
constant Kbit_ListboxEditable=0x02
constant Kbit_ListboxDoubleClickEdit=0x06
constant Kbit_ListboxShiftSelected=0x08
constant Kbit_ListboxChecked=0x30
constant Kbit_ListboxCheckbox=0x20
constant Kbit_ListboxDisclosure=0x40

function WaveBrowserListbox(controlName,windowName[,promptText,Xpos,Ypos,Xsize,Ysize,WaveOpts,procName])
	string controlName,windowName
	variable Xpos,Ypos,Xsize,Ysize
	string WaveOpts,promptText,procName

	string listBoxFolder
	
	if(paramisdefault(Xpos) || paramisdefault(Ypos))
		Xpos=5;Ypos=5
	endif
	if(paramisdefault(Xsize) || paramisdefault(Ysize))
		Xsize=100;Ysize=100
	endif
	if(paramisdefault(WaveOpts))
		waveOpts=""
	endif
	if(paramisdefault(PromptText))
		PromptText=""
	else
		TitleBox $(stringfromlist(0,controlName,"_")+"Title_"+stringfromlist(1,controlName,"_")),pos={Xpos,Ypos},size={Xsize,Ysize},title=promptText,fstyle=2^0
		Ypos+=18;Ysize-=18
	endif
	ListBox $controlName,pos={Xpos,Ypos},size={Xsize,Ysize},widths={300}

	MakeListIntoWaveSelector(windowName,controlName,content=WMWS_Waves,selectionMode=WMWS_SelectionSingle,listoptions=WaveOpts)
	if(!paramisdefault(procName))
		WS_SetNotificationProc(windowName, controlName, procname,isExtendedProc=1)
	endif
end

Function/t WBL_GetSelection(controlName,windowName)
	string controlName,windowName
	
	return stringfromlist(0,WS_SelectedObjectsList(windowName,controlName))
end

Function WBL_SetSelectedWave(controlName,windowName,waveref)
	string controlName,windowName
	wave/Z waveref
	
	WS_ClearSelection(windowName,controlName)
	if(waveexists(waveref))
		WS_SelectAnObject(windowName,controlName,getwavesdatafolder(waveref,2),openFoldersAsNeeded=1)
	endif
end

Function WBL_SetSelectedFolder(controlName,windowName,folderPath)
	string controlName,windowName
	string folderPath
	
	WS_ClearSelection(windowName,controlName)
	if(datafolderexists(folderPath))
		WS_OpenAFolderFully(windowName,controlName,FolderPath)
	endif
end

Function GenericTabs(ctrlName,tabNum) : TabControl	//control for generic tab system where controls are named with the tab number appended as _tab#
	String ctrlName	
	Variable tabNum

	GraphNormal	//Exits drawing mode if user is editing tuning ties
	
	String controlsInATab= ControlNameList("", ";", "*_tab*")					//gather control names
	
	String curTabMatch= "*_tab"+num2istr(tabNum)
	String controlsInCurTab= ListMatch(controlsInATab, curTabMatch)			//gather names of controls in selected tab
	String controlsInOtherTabs= ListMatch(controlsInATab, "!"+curTabMatch)	//gather names of controls in other tabs

	ModifyControlList controlsInOtherTabs disable=1	// hide
	ModifyControlList controlsInCurTab disable=0		// show

	return 0
End

